# Serenity/JS

[![npm version](https://badge.fury.io/js/serenity-js.svg)](https://badge.fury.io/js/serenity-js)
[![Build Status](https://travis-ci.org/jan-molak/serenity-js.svg?branch=master)](https://travis-ci.org/jan-molak/serenity-js)
[![Coverage Status](https://coveralls.io/repos/github/jan-molak/serenity-js/badge.svg)](https://coveralls.io/github/jan-molak/serenity-js)
[![Dependencies](https://david-dm.org/jan-molak/serenity-js.svg)](https://david-dm.org/jan-molak/serenity-js)
[![npm](https://img.shields.io/npm/dm/serenity-js.svg)](https://npm-stat.com/charts.html?package=serenity-js)
[![Known Vulnerabilities](https://snyk.io/test/github/jan-molak/serenity-js/badge.svg)](https://snyk.io/test/github/jan-molak/serenity-js)
[![semantic-release](https://img.shields.io/badge/%20%20%F0%9F%93%A6%F0%9F%9A%80-semantic--release-e10079.svg)](https://github.com/semantic-release/semantic-release)

Serenity/JS is a node.js library designed to make acceptance and regression testing of modern web applications
faster, more collaborative and easier to scale.

**Serenity/JS is a next generation acceptance testing library, expanding the capabilities of 
[Angular Protractor](https://github.com/angular/protractor) to give you:**
* **the flexibility and expressiveness of the [Screenplay Pattern](http://serenity-js.org/design/screenplay-pattern.html)**,  
  _so that your test scenarios stay free of noise and focused on the business logic_,
* **the power and visibility of [Serenity BDD](http://serenity-bdd.info/#/documentation)
[narrative reports](http://serenity-bdd.info/docs/serenity/#_detailed_description_of_aggregation_reports)**,  
  _so that failure analysis and release readiness assessment become more efficient_,
* **an easy way to introduce and follow [SOLID design principles](https://en.wikipedia.org/wiki/SOLID_&#40;object-oriented_design&#41;)**,  
  _to keep your code simple, reusable and easy to extend_,
* **effortless integration with popular test automation tools like [Cucumber](http://serenity-js.org/cucumber/readme.html), [Mocha](http://serenity-js.org/mocha/readme.html) and Chai**,  
  _so that you can introduce it into your existing toolchain **today**,  
  with just a single, [one-line code change](http://serenity-js.org/overview/retrofitting.html)_!

Although Serenity/JS provides strong support for automating web tests using Protractor and Webdriver,
it works very effectively for non-web tests too! Those include tests that exercise web services or even call application code directly.

**Find out more at [serenity-js.org](http://serenity-js.org)!**

[![Serenity/JS: Next Generation Acceptance Testing for Angular Apps](http://img.youtube.com/vi/YYgkFgBxEwc/0.jpg)](http://www.youtube.com/watch?v=YYgkFgBxEwc "Serenity/JS: Next Generation Acceptance Testing for Angular Apps")

## Help and Support

[http://serenity-js.org/support.html](http://serenity-js.org/support.html)

## Your feedback matters!

Do you find Serenity/JS useful? Give it a star! &#9733;

Found a bug? Need a feature? Raise [an issue](https://github.com/jan-molak/serenity-js/issues?state=open)
or submit a pull request.

Have feedback? Let me know on twitter: [@JanMolak](https://twitter.com/JanMolak)

## Friends of Serenity/JS

Serenity/JS is continuously delivered to you thanks to:
* the time and commitment of [the author](https://janmolak.com/) and [the contributors](https://github.com/jan-molak/serenity-js/graphs/contributors)
* a battery of browsers provided by [BrowserStack](https://www.browserstack.com)

[![tested on BrowserStack](docs/images/browserstack-logo.png)](http://bit.ly/JBMBS)

## License

Serenity/JS library is licensed under the [Apache-2.0](LICENSE.md) license.

----

_- Copyright &copy; 2016- [Jan Molak](https://janmolak.com) and the Serenity Team_

[![Analytics](https://ga-beacon.appspot.com/UA-85788349-2/serenity-js/readme.md?pixel)](https://github.com/igrigorik/ga-beacon)
